struct LogDensity{L} <: AbstractModel 
    density :: L
end

logdensity(model::LogDensity{<:Function}, x) = model.density(x)
logdensity(model::LogDensity{<:Distribution}, x) = logpdf(model.density, x)
logdensity(model::AbstractMCMC.LogDensityModel, x) = LogDensityProblems.logdensity(model.logdensity, x)

include("sample_based.jl")